/* PROGRAMA PLANTILLA PARA EL ECUALIZADOR EN LA ASIGNATURA P.S.I*/

#include <stdio.h>
#include <memory.h>
#include <led.h>
#include <axp.h>
#include <msg.h>
#include <stdlib.h>
#include <math.h>
#include <timer.h>

#include "record.h"
#include "rtdspc.h"

Msg             msg;
int             buffer;
AXPctrlBlk      blk;
unsigned long *pin;
unsigned long *pout;

int brkFnct()
{
	/* stop AXP processing */

	disableAXP();

	/* store last block to hard disk */

	msg.type = RECORD_LAST;
	msg.subtype = buffer;

	/* pass audio pointer in message */

	msg.data[0] = (int)blk.in.ptr;

	sendMsg(&msg,HOST_TASK,MSG_SYNC);

	return 0;
}

void main(int argc, char *argv[])
{
	int i;
	long int datin;
	float signal_in,signal_out;
	unsigned long inter;
	
	/* Note interrupt table must lay on a 512 word boundary */
	
	setIntVectorTable(INTERNAL_SRAM0);

	for(i=0;i<BUFFER_SIZE*2+1;i++)
	 *(unsigned long *)(BEGIN_BUF0+i)=0;
	initAXPctrlBlk(&blk,(void *)BEGIN_BUF0,BUFFER_SIZE,(void *)BEGIN_BUF1,BUFFER_SIZE,AXP_48K);
	
	enableAXP(&blk);
	*(int *)(0x50000000)=0x80000000;
	
	setCtrlBrkFnct(brkFnct);

	setAXPsampleRate(AXP_44_1K);    /*fija el ritmo de muestreo a 44.1 KHz.*/

	/* reset ptr to beginning of buffer */

	blk.in.ptr = (unsigned long *)BEGIN_BUF0;
	blk.out.ptr = (unsigned long *)BEGIN_BUF1;

	while(1)
	{
	pin=blk.in.ptr;
	while(pin==blk.in.ptr); /*se espera hasta que llegue una nueva muestra*/
	inter=*(unsigned long*)(0x40000000);
	inter=inter & 0x0000FFFF;

/*--------- Para poder trabajar sin problemas de signo con el long int */
	if ((inter & 0x00008000)!=0)
	  inter=inter | 0xFFFF0000;
	datin=inter;    /*esta asignacion intermedia parece fundamental!!!*/
	signal_in=(float)datin;        /*aqui se guarda el valor de entrada x[n]*/
/*---------------------------------------------------------------------*/
	/* EL PROGRAMA REALIZADO POR EL ALUMNO PUEDE SITUARSE A PARTIR DE AQUI */
	
	signal_out=signal_in;    /*aqui se guarda el valor de salida y[n]*/

	*(long int *)(0x40000000)=(long int)(signal_out);

	}
}
